/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the sidetone oscillator (beep) class

#ifndef KEYER_BEEP_H
#define KEYER_BEEP_H

#include <wirish.h>

#include "keyer_dma.h"
#include "keyer_receiver.h"

class keyer_beep : keyer_receiver
{
public:

    keyer_beep();
    void setup();
    void do_work(uint32_t message, uint32_t data);

private:

    static const int MAX_SAMPLES = 64;

    uint32_t m_freq;
    uint32_t m_ampl;
    bool m_phones;

    int m_samples;
    dma_channel m_dchannel;
    
    uint16_t m_ccr[MAX_SAMPLES];

    uint32_t m_owner;

    bool m_beeping;

    void set_output(uint32_t freq, uint32_t ampl, bool phones);
    void set_output();
    void on();
    void off();
};

extern keyer_beep beep;

#endif
