/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the bug emulation

#ifndef KEYER_BUG_H
#define KEYER_BUG_H

#include "keyer_config.h"
#include "keyer_manual.h"

class keyer_bug : public keyer_manual
{
public:
    keyer_bug();
    bool setup(keyer_type type, bool silent);
    void paddle_change(uint32_t id, uint32_t data);
    void state_change(keyer_state state);

private:
    bool m_cap_left;
    bool m_cap_right;
    bool m_phy_left;
    bool m_phy_right;

    bool m_dit_on;
    bool m_dah_on;

    bool m_sending_dit;
    bool m_sending_dah;

    uint32_t m_dits;

    bool left_paddle() { return m_cap_left || m_phy_left; }
    bool right_paddle() { return m_cap_right || m_phy_right; }
};

extern keyer_bug bug;
#endif
