/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the code and data which is common between the keyer and status keyer

#ifndef KEYER_COMMON_H
#define KEYER_COMMON_H

#include <wirish.h>

#include "keyer_misc.h"
#include "keyer_queue.h"

static const int MORSE_CHAR_SIZE (96 - 31);
extern const uint8_t morse_char[MORSE_CHAR_SIZE];

// The keyer dit time in milliseconds is 1200/speed.
static const int UNIT_MS = 1200;
static const int TIMER_UNIT = (UNIT_MS * TIMER_PER_MS);

static const uint8_t KEYER_MIN_SPEED = 5;
static const uint8_t KEYER_MAX_SPEED = 60;

static const uint8_t KEYER_MIN_WEIGHT = 10;
static const uint8_t KEYER_MAX_WEIGHT = 90;

static const uint32_t DIT_TICKS = 1;
static const uint32_t DAH_TICKS = 3;
static const uint32_t CHAR_TICKS = 3;
static const uint32_t WORD_TICKS_SHORT = 6;
static const uint32_t WORD_TICKS_LONG = 7;

#endif
