/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the rotary encoder 

#ifndef KEYER_ENCODER_H
#define KEYER_ENCODER_H

#include <wirish.h>
#include "keyer_receiver.h"

class keyer_encoder : keyer_receiver
{
public:
    keyer_encoder();
    void setup() {};
    void setup(uint32_t id, uint8_t pin_a, uint8_t pin_b, uint8_t pin_s);
    void do_work(uint32_t message, uint32_t data);

private:
    static void encoder_interrupt(void *data);
    static void button_interrupt(void *data);

    uint32_t m_id;

    uint8_t m_pin_a;
    uint8_t m_pin_b;
    uint8_t m_pin_s;

    uint32_t m_button;

    int32_t m_encoder_timer;
    int32_t m_button_timer;

    bool m_encoder_debounce;
    bool m_button_debounce;

    uint32_t m_b_val;

};

extern keyer_encoder encoder1;
extern keyer_encoder encoder2;
#endif
