/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the MPR121 capactive sensor class

#ifndef KEYER_MPR121_H
#define KEYER_MPR121_H

#include <wirish.h>
#include <libmaple/i2c.h>

#include <Wire.h>
#include "keyer_receiver.h"

class keyer_mpr121 : keyer_receiver
{
public:
    keyer_mpr121();
    void setup();

    void do_work(uint32_t message, uint32_t data);
    
private:
    bool m_left_pressed;
    bool m_right_pressed;

    static void interrupt();
    static void set_register(uint8_t reg, uint8_t val);
    uint8_t get_register(uint8_t reg);
};

extern keyer_mpr121 mpr121;
#endif
