/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

#ifndef KEYER_PINS_H
#define KEYER_PINS_H

// This defines the I/O pins used by the keyer.
//
// If you are considering changing the pins used be aware of the
// following:
//
// Input pins are tied to specific interrupts.  The interrupts can
// only be assigned to one pin (not shared).  So no two input pins
// can be assigned to the same interrupt (except some of the encoder
// pins if they are not using their interrupts).  Check the reference
// manual for the STM32F103 for more details.
//
// The amplifier shutdown pin must be 5V tolerant.
//
// The LED is soldered to the board.  Changing the LED pin is not
// practical.

#define HEADPHONE_AUDIO       PA0
#define SPEAKER_AUDIO         PA1
#define AMPLIFIER_SHUTDOWN    PB15

#define MPR121_INT            PB0

#define PADDLE_L              PB10
#define PADDLE_R              PB11

#define KEY1_OUT              PB12
#define PTT1_OUT              PB14

#define ENC1_A                PA15
#define ENC1_B                PA8
#define ENC1_S                PB4

#define ENC2_A                PB5
#define ENC2_B                PB8
#define ENC2_S                PB9

#define LED                   PC13

#endif
