/******************************************************************************
 * The MIT License
 *
 * Copyright (c) 2016, 2017 Paul Young
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *****************************************************************************/

// This contains the status keyer class

#ifndef KEYER_STATUS_H
#define KEYER_STATUS_H

#include <wirish.h>

#include "keyer_receiver.h"

const uint32_t MESSAGE_CHARS = 32;

class keyer_status : keyer_receiver
{
public:
    keyer_status();
    void setup();
    void do_work(uint32_t message, uint32_t data);

    void set_ticks(uint32_t ticks);

private:
    void update_speed();
    void send();
    void next_char();

    char m_message[MESSAGE_CHARS];
    uint32_t m_char;
    uint32_t m_last;

    uint8_t m_bits;
    bool m_sending;
    bool m_key_down;

    uint32_t m_ticks;

    int32_t m_timer;
    uint32_t m_sequence;
};

extern keyer_status status;

#endif
